//snake 16
//avoid wall and get cherry
//push START to turn right
//send ESC to exit

//about Image data
//http://www.picosoft.co.jp/ORANGE-light/image1616.html
//Copyright (c) 2019 Picosoft Co., Ltd.
//Made by Kaori Hanatsumi

cls 2
ESC = 0x1b

RED = rgb(255, 0, 0)
DARKRED = rgb(96, 0, 0)
DARKGREEN = rgb(20, 128, 0)
ORANGE = rgb(255, 165, 0)
WHITE = rgb(255, 255, 255)
BUTTON_START = 9

x=10:y=7:d=0:pre=1:len=3
cx=0:cy=0
ptr=0:MemMax=128

mptr MemMax

BLANK = getmptr()
mdata 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

WALL = getmptr()
mdata 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0x00, 0x00, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0x00, 0x00, 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0xDF, 0x00, 0x00, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0xFD, 0x00, 0x00

IG08 = getmptr() 'snake head?
mdata 0x00, 0x00, 0x07, 0xE0, 0x0F, 0xF0, 0x1F, 0xF8, 0x3F, 0xFC, 0x7F, 0xFE, 0x7F, 0xFE, 0x7F, 0xF6, 0x7F, 0xF6, 0x7F, 0xE6, 0x7F, 0xC6, 0x3E, 0x0C, 0x18, 0x18, 0x0F, 0xF0, 0x07, 0xE0, 0x00, 0x00

SL06 = getmptr() 'cherry
mdata 0x00, 0x00, 0x01, 0xF0, 0x00, 0xE0, 0x00, 0xB0, 0x01, 0x90, 0x01, 0x10, 0x03, 0x10, 0x02, 0x3C, 0x1C, 0x4E, 0x67, 0x5E, 0x6F, 0x7E, 0x7F, 0x7E, 0x7F, 0x3C, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00

for i=0 to 19
	gput16c(i,0,WALL,DARKRED)
	gput16c(i,14,WALL,DARKRED)
	if i<15 then gput16c(0,i,WALL,DARKRED):gput16c(19,i,WALL,DARKRED)
next
gprint 16,0,"SCORE:",WHITE,0

ch = sprnew(0, 0, 0, 16, 16, SL06, RED, 0)
move_cherry()

f=1
while f
	x = x + dx(d)
	y = y + dy(d)
	gput16c(getX(-len),getY(-len),BLANK,1)
	stamp(x,y)
	if trig() then d=(d+1)%4
	if x<1 or x>18 or y<1 or y>13 then f=0
	if hitcheck() then f=0
	if (cx == x) and (cy == y) then len=len+1:beep 33,50:move_cherry()
	gput16c(x, y, IG08, DARKGREEN)
	pause 100
	if inkey() = ESC then end
wend
gprint 120,100,"GAME OVER",WHITE,0
gprint 80,120,"Push START to Exit",ORANGE,0
beep 10,200

while in(BUTTON_START)
wend
end

def gput16c(x,y,adr,col) {
	sprnew(1, x*16, y*16, 16, 16, adr, col, 0)
	sprdsp 1, 1
}
def dx(d) {
	if d%2=0 then return d-1
	return 0
}
def dy(d) {
	if d%2=0 then return 0
	return d-2
}
def trig() {
	var rtn
	rtn = pre
	pre = in(BUTTON_START)
	return rtn & !pre
}
def stamp(x,y) {
	ptr = (ptr+2) % MemMax
	mpoke ptr,x
	mpoke ptr+1,y
}
def getX(offset) {
	return mpeek(((ptr + offset*2 + MemMax) % MemMax))
}
def getY(offset) {
	return mpeek(((ptr + offset*2 + MemMax +1) % MemMax))
}
def hitcheck() {
	var i
	var hit
	hit = 0
	i = len
	while i>0
		if getX(-i)==x and getY(-i)==y then i=1:hit=1
		i = i - 1
	wend
	return hit
}
def move_cherry() {
	cx = rnd(18) + 1
	cy = rnd(13) + 1
	sprmov ch,cx*16,cy*16
	sprdsp ch,1
	gprint 64,0,len,WHITE,0
}	